package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.FetchType;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.annotation.JsonBackReference;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPfKey;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_AMMTI_PIANI_FERIE")
public class DammtiPianiFerie extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 291445300L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DammtiPianiFerie.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_AMMTO_PIANI_FERIE", columnDefinition = "NUMBER(15)")
	private Long sequIdAmmtoPianiFerie;
	@Column(name = "DESC_MOTIVAZIONE_RIGETTO", columnDefinition = "VARCHAR(250)")
	private String descMotivazioneRigetto;
	@NotNull

	@Column(name = "STAT_ADESIONE", columnDefinition = "VARCHAR(1)")
	private String statAdesione;
	@NotNull

	@Column(name = "FK_AMMINISTRATO", columnDefinition = "NUMBER(15)")
	private Long fkAmministrato;
	@NotNull

	@Column(name = "FK_MOTIVAZIONE_ALERT_PF", columnDefinition = "NUMBER(15)")
	private Long fkMotivazioneAlertPf;
	@NotNull

	@Column(name = "FK_PIANO_FERIE", columnDefinition = "NUMBER(15)")
	private Long fkPianoFerie;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DammtiPianiFerie(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DammtiPianiFerie(DammtiPianiFerieKey dammtiPianiFerieKey, Long sequIdAmmtoPianiFerie,
			String descMotivazioneRigetto, String statAdesione, Long fkAmministrato, Long fkMotivazioneAlertPf,
			Long fkPianoFerie, String utenteUltimaModifica, Date dataFineRecord, Date dataUltimaModifica,
			String flagEliminato, Date dataInizioRecord) {
		super();

		this.dammtiPianiFerieKey = dammtiPianiFerieKey;

		this.sequIdAmmtoPianiFerie = sequIdAmmtoPianiFerie;
		this.descMotivazioneRigetto = descMotivazioneRigetto;
		this.statAdesione = statAdesione;
		this.fkAmministrato = fkAmministrato;
		this.fkMotivazioneAlertPf = fkMotivazioneAlertPf;
		this.fkPianoFerie = fkPianoFerie;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataFineRecord = dataFineRecord;
		this.dataUltimaModifica = dataUltimaModifica;
		this.flagEliminato = flagEliminato;
		this.dataInizioRecord = dataInizioRecord;
	}

	// CHILDREN

	// PARENTS
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDmotivazioniAlertPf")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DmotivazioniAlertPf theDmotivazioniAlertPf;
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "FK_PIANO_FERIE", referencedColumnName = "SEQU_ID_PIANO_FERIE", nullable = false)
	@JsonBackReference("theDpianiFerie")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DpianiFerie theDpianiFerie;

	// GETTER/SETTER
	/**
	 * @return the sequIdAmmtoPianiFerie
	 */
	public Long getSequIdAmmtoPianiFerie() {
		return this.sequIdAmmtoPianiFerie;
	}

	/**
	 * @param sequIdAmmtoPianiFerie to set
	 */
	public void setSequIdAmmtoPianiFerie(Long sequIdAmmtoPianiFerie) {
		this.sequIdAmmtoPianiFerie = sequIdAmmtoPianiFerie;
	}

	/**
	 * @return the descMotivazioneRigetto
	 */
	public String getDescMotivazioneRigetto() {
		return this.descMotivazioneRigetto;
	}

	/**
	 * @param descMotivazioneRigetto to set
	 */
	public void setDescMotivazioneRigetto(String descMotivazioneRigetto) {
		this.descMotivazioneRigetto = descMotivazioneRigetto;
	}

	/**
	 * @return the statAdesione
	 */
	public String getStatAdesione() {
		return this.statAdesione;
	}

	/**
	 * @param statAdesione to set
	 */
	public void setStatAdesione(String statAdesione) {
		this.statAdesione = statAdesione;
	}

	/**
	 * @return the fkAmministrato
	 */
	public Long getFkAmministrato() {
		return this.fkAmministrato;
	}

	/**
	 * @param fkAmministrato to set
	 */
	public void setFkAmministrato(Long fkAmministrato) {
		this.fkAmministrato = fkAmministrato;
	}

	/**
	 * @return the fkMotivazioneAlertPf
	 */
	public Long getFkMotivazioneAlertPf() {
		return this.fkMotivazioneAlertPf;
	}

	/**
	 * @param fkMotivazioneAlertPf to set
	 */
	public void setFkMotivazioneAlertPf(Long fkMotivazioneAlertPf) {
		this.fkMotivazioneAlertPf = fkMotivazioneAlertPf;
	}

	/**
	 * @return the fkPianoFerie
	 */
	public Long getFkPianoFerie() {
		return this.fkPianoFerie;
	}

	/**
	 * @param fkPianoFerie to set
	 */
	public void setFkPianoFerie(Long fkPianoFerie) {
		this.fkPianoFerie = fkPianoFerie;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	// CHILD GETTER/SETTER

	/// ADD CHILD

	// PARENT GETTER/SETTER
	/**
	 * @return the DmotivazioniAlertPf
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DmotivazioniAlertPf getTheDmotivazioniAlertPf() {
		return theDmotivazioniAlertPf;
	}

	/**
	 * @param aDmotivazioniAlertPfList to set
	 */
	public void setTheDmotivazioniAlertPf(DmotivazioniAlertPf aDmotivazioniAlertPf) {
		theDmotivazioniAlertPf = aDmotivazioniAlertPf;
	}

	/**
	 * @return the DpianiFerie
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DpianiFerie getTheDpianiFerie() {
		return theDpianiFerie;
	}

	/**
	 * @param aDpianiFerieList to set
	 */
	public void setTheDpianiFerie(DpianiFerie aDpianiFerie) {
		theDpianiFerie = aDpianiFerie;
	}

	// PARENT ID GETTER/SETTER
	/**
	 * Return the dmotivazioniAlertPfKey from theDmotivazioniAlertPf.
	 * 
	 * @return dmotivazioniAlertPfKey from theDmotivazioniAlertPf.
	 */
	@JsonProperty
	public DmotivazioniAlertPfKey getDmotivazioniAlertPfKey() {
		// If the parent entity object is null, then return null
		if (getTheDmotivazioniAlertPf() == null) {
			return null;
		}
		// Return requested attribute
		return theDmotivazioniAlertPf.getDmotivazioniAlertPfKey();
	}

	/**
	 * Return the sequIdPianoFerie from theDpianiFerie.
	 * 
	 * @return sequIdPianoFerie from theDpianiFerie.
	 */
	@JsonProperty
	public Long getSequIdPianoFerie() {
		// If the parent entity object is null, then return null
		if (getTheDpianiFerie() == null) {
			return null;
		}
		// Return requested attribute
		return theDpianiFerie.getSequIdPianoFerie();
	}

	// PARENT OBJECT TITLE
	/**
	 * Return the object title of theDmotivazioniAlertPf.
	 * 
	 * @return the object title of theDmotivazioniAlertPf.
	 */
	@JsonProperty
	public String getTheDmotivazioniAlertPfObjectTitle() {
		return getTheDmotivazioniAlertPf() != null ? getTheDmotivazioniAlertPf().getObjectTitle() : null;
	}

	/**
	 * Return the object title of theDpianiFerie.
	 * 
	 * @return the object title of theDpianiFerie.
	 */
	@JsonProperty
	public String getTheDpianiFerieObjectTitle() {
		return getTheDpianiFerie() != null ? getTheDpianiFerie().getObjectTitle() : null;
	}

	// PARENT OBJECT KEY
	/**
	 * Return the object key of theDmotivazioniAlertPf.
	 * 
	 * @return the object key of theDmotivazioniAlertPf.
	 */
	@JsonProperty
	public String getTheDmotivazioniAlertPfObjectKey() {
		return getTheDmotivazioniAlertPf() != null ? getTheDmotivazioniAlertPf().getObjectKey() : null;
	}

	/**
	 * Set object key of theDmotivazioniAlertPf.
	 * 
	 */
	@JsonProperty
	public void setTheDmotivazioniAlertPfObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDmotivazioniAlertPfObjectKey(), objectKey, false)) {
			DmotivazioniAlertPf dmotivazioniAlertPf = new DmotivazioniAlertPf();
			dmotivazioniAlertPf.setObjectKey(objectKey);
			setTheDmotivazioniAlertPf(dmotivazioniAlertPf);
		}
	}

	/**
	 * Return the object key of theDpianiFerie.
	 * 
	 * @return the object key of theDpianiFerie.
	 */
	@JsonProperty
	public String getTheDpianiFerieObjectKey() {
		return getTheDpianiFerie() != null ? getTheDpianiFerie().getObjectKey() : null;
	}

	/**
	 * Set object key of theDpianiFerie.
	 * 
	 */
	@JsonProperty
	public void setTheDpianiFerieObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDpianiFerieObjectKey(), objectKey, false)) {
			DpianiFerie dpianiFerie = new DpianiFerie();
			dpianiFerie.setObjectKey(objectKey);
			setTheDpianiFerie(dpianiFerie);
		}
	}

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDammtiPianiFerieKey());
	}

	public String getObjectKeyById(DammtiPianiFerieKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dammtiPianiFerieKey = new DammtiPianiFerieKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getDescMotivazioneRigetto());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DammtiPianiFerieKey dammtiPianiFerieKey;

	// GETTER/SETTER CK
	/**
	 * @return the dammtiPianiFerieKey
	 */
	public DammtiPianiFerieKey getDammtiPianiFerieKey() {
		return this.dammtiPianiFerieKey;
	}

	/**
	 * @param dammtiPianiFerieKey to set
	 */
	public void setDammtiPianiFerieKey(DammtiPianiFerieKey dammtiPianiFerieKey) {
		this.dammtiPianiFerieKey = dammtiPianiFerieKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dammtiPianiFerieKey == null) {
			dammtiPianiFerieKey = new DammtiPianiFerieKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DammtiPianiFerie that = (DammtiPianiFerie) o;
		return dammtiPianiFerieKey != null && Objects.equals(dammtiPianiFerieKey, that.dammtiPianiFerieKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dammtiPianiFerieKey);
	}
}
